#### Executing AS AT player
execute as @e[tag=hotbar_item] at @s run execute at @p[tag=ride_initialized] run tp @s ~ ~256 ~

################################
######## Teleport Parts ########
################################


######## Relative to Turret

execute store result entity @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1] Rotation[0] float 1 run data get entity @s Rotation[0] 1
execute store result entity @e[type=armor_stand,distance=0..1,tag=tank_turret,sort=nearest,limit=1] Rotation[0] float 1 run data get entity @s Rotation[0] 1


######## TEST FOR FUEL, replace with less fuel, add fuel to tank ########

execute if entity @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=0}] if entity @e[type=chest_minecart,distance=0..4,tag=tank_storage,nbt={Items:[{Slot:0b,id:"minecraft:enchanted_book",Count:1b,tag:{tank_fuel:1b}}]}] run scoreboard players set @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1] tank_fuel 18001
execute if entity @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=18001}] as @e[type=chest_minecart,distance=0..4,tag=tank_storage,nbt={Items:[{Slot:0b,id:"minecraft:enchanted_book",Count:1b,tag:{tank_fuel:1b}}]}] run replaceitem entity @s container.0 minecraft:air
execute if entity @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=18001}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1] tank_fuel 1

execute if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankl:1b}}}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] tank_fuel 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankfl:1b}}}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] tank_fuel 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankf:1b}}}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] tank_fuel 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankfr:1b}}}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] tank_fuel 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankr:1b}}}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] tank_fuel 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankb:1b}}}] run scoreboard players remove @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] tank_fuel 1

#######################################
######## Hotbar Item Functions ########
#######################################

######## Give Items
replaceitem entity @s container.0 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Barrel Up\"}"},CustomModelData:987610,tankbarrelup:1b}
replaceitem entity @s container.1 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Barrel Down\"}"},CustomModelData:987611,tankbarreldown:1b}
replaceitem entity @s container.2 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Spin Left\"}"},CustomModelData:98764,tankl:1b}
replaceitem entity @s container.3 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Drive Left Forwards\"}"},CustomModelData:98765,tankfl:1b}
replaceitem entity @s container.4 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Drive Forwards\"}"},CustomModelData:98766,tankf:1b}
replaceitem entity @s container.5 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Drive Right Forwards\"}"},CustomModelData:98767,tankfr:1b}
replaceitem entity @s container.6 minecraft:carrot_on_a_stick{Unbreakable:1b,display:{Name:"{\"text\":\"Spin Right\"}"},CustomModelData:98768,tankr:1b}
# 7 is Ammo Slot
replaceitem entity @s container.8 minecraft:carrot_on_a_stick{display:{Name:"{\"text\":\"Drive Backwards\"}"},CustomModelData:98769,tankb:1b}

######## Barrel Up/Down
execute if entity @s[scores={tank_rc=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankbarrelup:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1] at @s if entity @s[scores={barrel_degree=-48..0}] run tp @s ~ ~ ~ ~ ~-2
execute if entity @s[scores={tank_rc=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankbarrelup:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1] if entity @s[scores={barrel_degree=-48..0}] run scoreboard players remove @s barrel_degree 2


execute if entity @s[scores={tank_rc=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankbarreldown:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1] at @s if entity @s[scores={barrel_degree=-50..-2}] run tp @s ~ ~ ~ ~ ~2
execute if entity @s[scores={tank_rc=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankbarreldown:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1] if entity @s[scores={barrel_degree=-50..-2}] run scoreboard players add @s barrel_degree 2


######## Barrel Manual Pose 

execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-0}] run data merge entity @s {Pose:{Head:[-0f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-2}] run data merge entity @s {Pose:{Head:[-2f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-4}] run data merge entity @s {Pose:{Head:[-4f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-6}] run data merge entity @s {Pose:{Head:[-6f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-8}] run data merge entity @s {Pose:{Head:[-8f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-10}] run data merge entity @s {Pose:{Head:[-10f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-12}] run data merge entity @s {Pose:{Head:[-12f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-14}] run data merge entity @s {Pose:{Head:[-14f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-16}] run data merge entity @s {Pose:{Head:[-16f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-18}] run data merge entity @s {Pose:{Head:[-18f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-20}] run data merge entity @s {Pose:{Head:[-20f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-22}] run data merge entity @s {Pose:{Head:[-22f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-24}] run data merge entity @s {Pose:{Head:[-24f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-26}] run data merge entity @s {Pose:{Head:[-26f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-28}] run data merge entity @s {Pose:{Head:[-28f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-30}] run data merge entity @s {Pose:{Head:[-30f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-32}] run data merge entity @s {Pose:{Head:[-32f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-34}] run data merge entity @s {Pose:{Head:[-34f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-36}] run data merge entity @s {Pose:{Head:[-36f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-38}] run data merge entity @s {Pose:{Head:[-38f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-40}] run data merge entity @s {Pose:{Head:[-40f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-42}] run data merge entity @s {Pose:{Head:[-42f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-44}] run data merge entity @s {Pose:{Head:[-44f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-46}] run data merge entity @s {Pose:{Head:[-46f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-48}] run data merge entity @s {Pose:{Head:[-48f,0f,0f]}}
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_degree=-50}] run data merge entity @s {Pose:{Head:[-50f,0f,0f]}}


######## Collision ########

######## Add Tags
execute at @e[type=armor_stand,tag=hitbox_fr,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add fr
execute at @e[type=armor_stand,tag=hitbox_fl,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add fl
execute at @e[type=armor_stand,tag=hitbox_fr1,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add fr1
execute at @e[type=armor_stand,tag=hitbox_fl1,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add fl1
execute at @e[type=armor_stand,tag=hitbox_f,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add f

execute at @e[type=armor_stand,tag=hitbox_br,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add br
execute at @e[type=armor_stand,tag=hitbox_bl,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add bl
execute at @e[type=armor_stand,tag=hitbox_br1,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add br1
execute at @e[type=armor_stand,tag=hitbox_bl1,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add bl1
execute at @e[type=armor_stand,tag=hitbox_b,sort=nearest,limit=1] unless block ~ ~1 ~ air run tag @s add b

execute at @e[type=armor_stand,tag=hitbox_barrel,sort=nearest,limit=1] unless block ~ ~ ~ air run tag @s add barrel_stuck
execute at @e[type=armor_stand,tag=hitbox_barrel2,sort=nearest,limit=1] unless block ~ ~ ~ air run tag @s add barrel_stuck
execute at @e[type=armor_stand,tag=hitbox_barrel3,sort=nearest,limit=1] unless block ~ ~ ~ air run tag @s add barrel_stuck

execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] unless block ^ ^1 ^1 air run tag @s add l
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] unless block ^ ^1 ^2 air run tag @s add l
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] unless block ^ ^1 ^3 air run tag @s add l
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] unless block ^ ^1 ^-1 air run tag @s add lb
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] unless block ^ ^1 ^-2 air run tag @s add lb
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] unless block ^ ^1 ^-3 air run tag @s add lb

execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] unless block ^ ^1 ^1 air run tag @s add r
execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] unless block ^ ^1 ^2 air run tag @s add r
execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] unless block ^ ^1 ^3 air run tag @s add r
execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] unless block ^ ^1 ^-1 air run tag @s add rb
execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] unless block ^ ^1 ^-2 air run tag @s add rb
execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] unless block ^ ^1 ^-3 air run tag @s add rb

######## Remove Tags
execute at @e[type=armor_stand,tag=hitbox_fr,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove fr
execute at @e[type=armor_stand,tag=hitbox_fl,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove fl
execute at @e[type=armor_stand,tag=hitbox_fr1,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove fr1
execute at @e[type=armor_stand,tag=hitbox_fl1,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove fl1
execute at @e[type=armor_stand,tag=hitbox_f,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove f

execute at @e[type=armor_stand,tag=hitbox_br,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove br
execute at @e[type=armor_stand,tag=hitbox_bl,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove bl
execute at @e[type=armor_stand,tag=hitbox_br1,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove br1
execute at @e[type=armor_stand,tag=hitbox_bl1,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove bl1
execute at @e[type=armor_stand,tag=hitbox_b,sort=nearest,limit=1] if block ~ ~1 ~ air run tag @s remove b

execute at @e[type=armor_stand,tag=hitbox_barrel,sort=nearest,limit=1] if block ~ ~ ~ air at @e[type=armor_stand,tag=hitbox_barrel2,sort=nearest,limit=1] if block ~ ~ ~ air at @e[type=armor_stand,tag=hitbox_barrel3,sort=nearest,limit=1] if block ~ ~ ~ air run tag @s remove barrel_stuck

execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] if block ^ ^1 ^1 air if block ^ ^1 ^2 air if block ^ ^1 ^3 air run tag @s remove l
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] if block ^ ^1 ^-1 air if block ^ ^1 ^-2 air if block ^ ^1 ^-3 air run tag @s remove lb

execute at @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] if block ^ ^1 ^1 air if block ^ ^1 ^2 air if block ^ ^1 ^3 air run tag @s remove r
execute at @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] if block ^ ^1 ^-1 air if block ^ ^1 ^-2 air if block ^ ^1 ^-3 air run tag @s remove rb

###############################
######## Main Movement ########
###############################

######## 6 Directions
execute if entity @s[tag=!l,tag=!rb,tag=!fl,tag=!br,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankl:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] at @s run tp @s ~ ~ ~ ~-3 ~


execute if entity @s[tag=!l,tag=!fl1,tag=!br1,tag=!f,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankfl:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] at @s run tp @s ^ ^ ^0.3 ~-3 ~


execute if entity @s[tag=!fr,tag=!fr1,tag=!f,tag=!fl1,tag=!fl,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankf:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] at @s run tp @s ^ ^ ^0.3


execute if entity @s[tag=!r,tag=!fr1,tag=!bl1,tag=!f,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankfr:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] at @s run tp @s ^ ^ ^0.3 ~3 ~


execute if entity @s[tag=!lb,tag=!r,tag=!fr,tag=!bl,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankr:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] at @s run tp @s ~ ~ ~ ~3 ~


execute if entity @s[tag=!br,tag=!br1,tag=!b,tag=!bl1,tag=!bl,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{tankb:1b}}}] run execute as @e[type=armor_stand,distance=0..2,tag=tank_center,sort=nearest,limit=1,scores={tank_fuel=1..}] at @s run tp @s ^ ^ ^-0.3



#######################
######## SHOOT ########
#######################

######## Scoreboard
execute as @a[scores={tank_rc=1..}] run scoreboard players set @s tank_rc 0
execute as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_cooldown=1..60}] run scoreboard players remove @s barrel_cooldown 1
######## Detect dropped carrot on stick
#### Run summon_tank_projectile

execute if entity @s[tag=!barrel_stuck,nbt={Inventory:[{Slot:7b,id:"minecraft:iron_nugget",tag:{heat_round:1b}}]}] if entity @e[distance=0..2,type=item,nbt={Item:{id:"minecraft:carrot_on_a_stick"}}] as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1,scores={barrel_cooldown=0}] at @s positioned ~ ~1 ~ positioned ^ ^ ^4 run function tank_pack:summon_tank_projectile
#### Kill carrot stick
execute as @e[distance=0..2,type=item,nbt={Item:{id:"minecraft:carrot_on_a_stick"}}] run kill @s
