###########################
######## WORKBENCH ########
###########################

######## Setup

execute as @e[type=item,nbt={Item:{id:"minecraft:anvil"}}] at @s if block ~ ~-1 ~ minecraft:crafting_table run summon item_frame ~ ~-1 ~ {Facing:1b,Tags:["tempFrame"]}
execute as @e[type=item,nbt={Item:{id:"minecraft:anvil"}}] at @s if block ~ ~-1 ~ minecraft:crafting_table run playsound minecraft:block.anvil.land master @a ~ ~ ~
execute as @e[type=item,nbt={Item:{id:"minecraft:anvil"}}] at @s if block ~ ~-1 ~ minecraft:crafting_table run setblock ~ ~-1 ~ minecraft:dropper[facing=down]{CustomName:"{\"text\":\"Workbench\",\"color\":\"yellow\"}"}
execute as @e[type=item_frame,tag=tempFrame] at @s run summon armor_stand ~ ~ ~ {NoGravity:1b,Invisible:1b,Invulnerable:1b,Tags:["workbench"]}
execute as @e[type=item,nbt={Item:{id:"minecraft:anvil"}}] at @s if entity @e[type=item_frame,tag=tempFrame,distance=0..2] run kill @s
execute as @e[type=item_frame,tag=tempFrame] at @s run kill @s

execute as @e[type=armor_stand,tag=workbench] at @s unless block ~ ~ ~ dropper run kill @e[type=item]
execute as @e[type=armor_stand,tag=workbench] at @s unless block ~ ~ ~ dropper run playsound minecraft:block.anvil.destroy master @a ~ ~ ~ 1 2
execute as @e[type=armor_stand,tag=workbench] at @s unless block ~ ~ ~ dropper run playsound minecraft:block.anvil.place master @a ~ ~ ~ 1 1.5
execute as @e[type=armor_stand,tag=workbench] at @s unless block ~ ~ ~ dropper run kill @s

######## Crafting ########

######## Detection and Dropper Flip 1

#### Engine
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:0b,id:"minecraft:piston",Count:1b},{Slot:1b,id:"minecraft:redstone_block",Count:1b},{Slot:2b,id:"minecraft:piston",Count:1b},{Slot:3b,id:"minecraft:furnace",Count:1b},{Slot:4b,id:"minecraft:blast_furnace",Count:1b},{Slot:5b,id:"minecraft:furnace",Count:1b},{Slot:6b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:7b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:8b,id:"minecraft:iron_trapdoor",Count:1b}]} run setblock ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:piston",Count:1b},{Slot:1b,id:"minecraft:redstone_block",Count:1b},{Slot:2b,id:"minecraft:piston",Count:1b},{Slot:3b,id:"minecraft:furnace",Count:1b},{Slot:4b,id:"minecraft:blast_furnace",Count:1b},{Slot:5b,id:"minecraft:furnace",Count:1b},{Slot:6b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:7b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:8b,id:"minecraft:iron_trapdoor",Count:1b}]}

#### Compressed Charcoal
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:4b,id:"minecraft:charcoal",Count:64b}]} run setblock ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:4b,id:"minecraft:charcoal",Count:64b}]}

#### Ammo
# HEAT
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:1b},{Slot:4b,id:"minecraft:gunpowder",Count:4b}]} run setblock ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:1b},{Slot:4b,id:"minecraft:gunpowder",Count:4b}]}

execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:16b},{Slot:4b,id:"minecraft:gunpowder",Count:64b}]} run setblock ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:16b},{Slot:4b,id:"minecraft:gunpowder",Count:64b}]}

######## Sound and Item Appearance/Flip 2

#### Engine
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:piston",Count:1b},{Slot:1b,id:"minecraft:redstone_block",Count:1b},{Slot:2b,id:"minecraft:piston",Count:1b},{Slot:3b,id:"minecraft:furnace",Count:1b},{Slot:4b,id:"minecraft:blast_furnace",Count:1b},{Slot:5b,id:"minecraft:furnace",Count:1b},{Slot:6b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:7b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:8b,id:"minecraft:iron_trapdoor",Count:1b}]} run playsound minecraft:block.anvil.use master @a ~ ~ ~ 1 1
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:0b,id:"minecraft:piston",Count:1b},{Slot:1b,id:"minecraft:redstone_block",Count:1b},{Slot:2b,id:"minecraft:piston",Count:1b},{Slot:3b,id:"minecraft:furnace",Count:1b},{Slot:4b,id:"minecraft:blast_furnace",Count:1b},{Slot:5b,id:"minecraft:furnace",Count:1b},{Slot:6b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:7b,id:"minecraft:iron_trapdoor",Count:1b},{Slot:8b,id:"minecraft:iron_trapdoor",Count:1b}]} run setblock ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:4b,id:"minecraft:armor_stand",Count:1b,tag:{display:{Name:"{\"text\":\"Tank Engine\",\"color\":\"red\"}",Lore:["{\"text\":\"Place facing barrel\"}"]},EntityTag:{Invulnerable:1b,NoGravity:1,CustomName:"{\"text\":\"tank_engine\"}"}}}]} replace

#### Compressed Charcoal
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:4b,id:"minecraft:charcoal",Count:64b}]} run playsound minecraft:block.anvil.use master @a ~ ~ ~ 1 1
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:4b,id:"minecraft:charcoal",Count:64b}]} run setblock ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:4b,id:"minecraft:enchanted_book",Count:1b,tag:{tank_fuel:1b,HideFlags:1,CustomModelData:987613,display:{Name:"{\"text\":\"Compressed Charcoal\",\"color\":\"red\"}",Lore:["{\"text\":\"Used to fuel tanks. Place in Top Left of Fuel Chest\"}"]}}}]} replace

#### Ammo
# HEAT
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:1b},{Slot:4b,id:"minecraft:gunpowder",Count:4b}]} run playsound minecraft:block.anvil.use master @a ~ ~ ~ 1 1
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:1b},{Slot:4b,id:"minecraft:gunpowder",Count:4b}]} run setblock ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:4b,id:"minecraft:iron_nugget",Count:4b,tag:{heat_round:1b,CustomModelData:987614,display:{Name:"{\"text\":\"HEAT Round\",\"color\":\"red\"}",Lore:["{\"text\":\"Moderate Armor Penetration\"}"]}}}]}

execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:16b},{Slot:4b,id:"minecraft:gunpowder",Count:64b}]} run playsound minecraft:block.anvil.use master @a ~ ~ ~ 1 1
execute as @e[type=armor_stand,tag=workbench] at @s if block ~ ~ ~ minecraft:dropper[facing=up]{Items:[{Slot:1b,id:"minecraft:heavy_weighted_pressure_plate",Count:16b},{Slot:4b,id:"minecraft:gunpowder",Count:64b}]} run setblock ~ ~ ~ minecraft:dropper[facing=down]{Items:[{Slot:4b,id:"minecraft:iron_nugget",Count:64b,tag:{heat_round:1b,CustomModelData:987614,display:{Name:"{\"text\":\"HEAT Round\",\"color\":\"red\"}",Lore:["{\"text\":\"Moderate Armor Penetration\"}"]}}}]}

########################
######## ENGINE ########
########################

######## Summon Engine Spawner and Armor Stand

execute as @e[name=tank_engine] at @s unless entity @s[tag=spawner_placed] run setblock ~ ~ ~ minecraft:spawner{SpawnCount:0,SpawnRange:0,SpawnData:{id:"minecraft:area_effect_cloud",Particle:"dust"},Delay:0,MaxNearbyEntities:0,RequiredPlayerRange:0} replace

execute as @e[name=tank_engine] at @s unless entity @s[tag=spawner_placed] run playsound minecraft:entity.iron_golem.step master @a ~ ~ ~ 1 1
execute as @e[name=tank_engine] at @s unless entity @s[tag=spawner_placed] run playsound minecraft:entity.iron_golem.hurt master @a ~ ~ ~ 1 1.2
execute as @e[name=tank_engine] at @s unless entity @s[tag=spawner_placed] run playsound minecraft:block.lava.extinguish master @a ~ ~ ~ 1 2


tag @e[name=tank_engine] add spawner_placed
execute as @e[name=tank_engine] at @s unless block ~ ~ ~ spawner run summon item ~ ~0.5 ~ {Item:{id:"minecraft:armor_stand",Count:1b,tag:{display:{Name:"{\"text\":\"Tank Engine\",\"color\":\"red\"}",Lore:["{\"text\":\"Place facing cannon\"}"]},CustomModelData:100001,EntityTag:{Invulnerable:1b,NoGravity:1b,CustomName:"{\"text\":\"tank_engine\"}"}}}}
execute as @e[name=tank_engine] at @s unless block ~ ~ ~ spawner run kill @e[type=experience_orb]
execute as @e[name=tank_engine] at @s unless block ~ ~ ~ spawner run kill @s

######## Loop tank_engine

execute as @e at @e[name=tank_engine,tag=!active_tank] run function tank_pack:tank_engine

############################
######## TANK SETUP ########
############################

######## START AND LOOP tank_ride on all tank riders
execute as @a[tag=!ride_initialized,nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] at @s run function tank_pack:tank_ride_initialize

#### Prevent Minecart Pushing
execute as @e[tag=tank_seat] run data merge entity @s {Motion:[0.0d,0.0d,0.0d]}
execute as @e[tag=tank_storage] run data merge entity @s {Motion:[0.0d,0.0d,0.0d]}

#### Ride
execute as @a[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] at @s run function tank_pack:tank_ride

#############################################
######## TANK TELEPORTATION OF PARTS ########
#############################################

#-# CRUSH
execute as @e[tag=tank_part] at @s unless block ~ ~ ~ air run function tank_pack:crush

######## Kill Tanks ########
execute as @e[tag=tank_part,type=!slime] at @s unless entity @e[tag=tank_center,distance=0..8] run kill @s
execute as @e[tag=tank_part,type=slime] at @s unless entity @e[tag=tank_center,distance=0..8] run tp @s ~ ~-255 ~


execute as @e[tag=tank_center,scores={tank_hp=..0}] at @s run particle minecraft:explosion_emitter ~ ~ ~
execute as @e[tag=tank_center,scores={tank_hp=..0}] at @s run playsound minecraft:entity.generic.explode master @a ~ ~ ~
execute as @e[tag=tank_center,scores={tank_hp=..0}] run kill @s

execute as @e[tag=tank_barrel] at @s if entity @e[tag=tank_barrel,distance=0.1..2] run particle minecraft:explosion_emitter ~ ~ ~
execute as @e[tag=tank_barrel] at @s if entity @e[tag=tank_barrel,distance=0.1..2] run playsound minecraft:entity.generic.explode master @a ~ ~ ~
execute as @e[tag=tank_barrel] at @s if entity @e[tag=tank_barrel,distance=0.1..2] run kill @e[tag=tank_center,limit=2,sort=nearest]

#### 
######## Barrel
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_barrel,sort=nearest,limit=1] at @e[type=armor_stand,distance=0..3,tag=tank_barrel,sort=nearest,limit=1] run tp @s ^ ^1.5 ^3 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_barrel2,sort=nearest,limit=1] at @e[type=armor_stand,distance=0..3,tag=tank_barrel,sort=nearest,limit=1] run tp @s ^ ^1.5 ^2 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_barrel3,sort=nearest,limit=1] at @e[type=armor_stand,distance=0..3,tag=tank_barrel,sort=nearest,limit=1] run tp @s ^ ^1.5 ^1 ~ ~


######## Hitbox
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_fr,sort=nearest,limit=1] run tp @s ^-2 ^ ^4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_fl,sort=nearest,limit=1] run tp @s ^2 ^ ^4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_fr1,sort=nearest,limit=1] run tp @s ^-1 ^ ^4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_fl1,sort=nearest,limit=1] run tp @s ^1 ^ ^4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_f,sort=nearest,limit=1] run tp @s ^ ^ ^4 ~ ~

execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_bl,sort=nearest,limit=1] run tp @s ^2 ^ ^-4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_br,sort=nearest,limit=1] run tp @s ^-2 ^ ^-4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_bl1,sort=nearest,limit=1] run tp @s ^1 ^ ^-4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_br1,sort=nearest,limit=1] run tp @s ^-1 ^ ^-4 ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_b,sort=nearest,limit=1] run tp @s ^ ^ ^-4 ~ ~

execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_l,sort=nearest,limit=1] run tp @s ^2 ^ ^ ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,tag=hitbox_r,sort=nearest,limit=1] run tp @s ^-2 ^ ^ ~ ~

######## Turret and Carts
execute at @e[type=armor_stand,tag=tank_center] as @e[type=armor_stand,tag=tank_turret,sort=nearest,limit=1] run tp @s ~ ~ ~
execute at @e[type=armor_stand,tag=tank_center] as @e[type=chest_minecart,distance=0..4,tag=tank_storage,sort=nearest,limit=1] run tp @s ^ ^0.9 ^-2.8 ~90 ~
execute at @e[type=armor_stand,tag=tank_center] as @e[type=minecart,distance=0..3,tag=tank_seat,sort=nearest,limit=1] run tp @s ~ ~1 ~

# Other parts
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=slime,distance=0..3,tag=tank_rc_slime,sort=nearest,limit=1] at @e[type=armor_stand,distance=0..1,tag=tank_turret,sort=nearest,limit=1] positioned ^ ^1.5 ^1 run tp @s ~ ~ ~ ~ ~
execute as @e[type=armor_stand,tag=tank_center] at @s as @e[type=armor_stand,distance=0..2,tag=tank_barrel,sort=nearest,limit=1] at @e[type=armor_stand,distance=0..1,tag=tank_turret,sort=nearest,limit=1] positioned ^ ^0.5 ^1 run tp @s ~ ~ ~

######## Gravity
#### Down
execute unless entity @e[tag=bug_fix_pls] as @e[type=armor_stand,tag=tank_center,tag=Down] run tag @s remove Down

execute unless entity @e[tag=bug_fix_pls] as @e[type=armor_stand,tag=tank_center,tag=!Down] at @s if block ^2 ^-1 ^1 air if block ^2 ^-1 ^2 air if block ^2 ^-1 ^3 air if block ^2 ^-1 ^-3 air if block ^2 ^-1 ^-1 air if block ^2 ^-1 ^-2 air if block ^2 ^-1 ^ air if block ^1 ^-1 ^1 air if block ^1 ^-1 ^2 air if block ^1 ^-1 ^3 air if block ^1 ^-1 ^-3 air if block ^1 ^-1 ^-1 air if block ^1 ^-1 ^-2 air if block ^1 ^-1 ^ air if block ^ ^-1 ^1 air if block ^ ^-1 ^2 air if block ^ ^-1 ^3 air if block ^ ^-1 ^-3 air if block ^ ^-1 ^-1 air if block ^ ^-1 ^-2 air if block ^ ^-1 ^ air if block ^-1 ^-1 ^1 air if block ^-1 ^-1 ^2 air if block ^-1 ^-1 ^3 air if block ^-1 ^-1 ^-3 air if block ^-1 ^-1 ^-1 air if block ^-1 ^-1 ^-2 air if block ^-1 ^-1 ^ air if block ^-2 ^-1 ^1 air if block ^-2 ^-1 ^2 air if block ^-2 ^-1 ^-1 air if block ^-2 ^-1 ^-2 air if block ^-2 ^-1 ^-3 air if block ^-2 ^-1 ^3 air if block ^-2 ^-1 ^ air run tag @s add Down

execute unless entity @e[tag=bug_fix_pls] as @e[tag=tank_center,type=armor_stand,tag=Down] at @s run tp @s ~ ~-1 ~

#### Up

# If all air, add notUp after removing it first
execute unless entity @e[tag=bug_fix_pls] as @e[type=armor_stand,tag=tank_center,tag=notUp] run tag @s remove notUp

execute as @e[type=armor_stand,tag=tank_center,tag=!notUp] at @s if block ^2 ^ ^1 air if block ^2 ^ ^2 air if block ^2 ^ ^3 air if block ^2 ^ ^-3 air if block ^2 ^ ^-1 air if block ^2 ^ ^-2 air if block ^2 ^ ^ air if block ^1 ^ ^1 air if block ^1 ^ ^2 air if block ^1 ^ ^3 air if block ^1 ^ ^-3 air if block ^1 ^ ^-1 air if block ^1 ^ ^-2 air if block ^1 ^ ^ air if block ^ ^ ^1 air if block ^ ^ ^2 air if block ^ ^ ^3 air if block ^ ^ ^-3 air if block ^ ^ ^-1 air if block ^ ^ ^-2 air if block ^ ^ ^ air if block ^-1 ^ ^1 air if block ^-1 ^ ^2 air if block ^-1 ^ ^3 air if block ^-1 ^ ^-3 air if block ^-1 ^ ^-1 air if block ^-1 ^ ^-2 air if block ^-1 ^ ^ air if block ^-2 ^ ^1 air if block ^-2 ^ ^2 air if block ^-2 ^ ^-1 air if block ^-2 ^ ^-2 air if block ^-2 ^ ^-3 air if block ^-2 ^ ^3 air if block ^-2 ^ ^ air run tag @s add notUp
# Doesn't let you climb if blocked

execute unless entity @e[tag=bug_fix_pls] as @e[type=armor_stand,tag=tank_center,tag=Up] run tag @s remove Up

execute as @e[type=armor_stand,tag=tank_center,tag=!Up] at @s if block ^2 ^2 ^1 air if block ^2 ^2 ^2 air if block ^2 ^2 ^3 air if block ^2 ^2 ^-3 air if block ^2 ^2 ^-1 air if block ^2 ^2 ^-2 air if block ^2 ^2 ^ air if block ^1 ^2 ^1 air if block ^1 ^2 ^2 air if block ^1 ^2 ^3 air if block ^1 ^2 ^-3 air if block ^1 ^2 ^-1 air if block ^1 ^2 ^-2 air if block ^1 ^2 ^ air if block ^ ^2 ^1 air if block ^ ^2 ^2 air if block ^ ^2 ^3 air if block ^ ^2 ^-3 air if block ^ ^2 ^-1 air if block ^ ^2 ^-2 air if block ^ ^2 ^ air if block ^-1 ^2 ^1 air if block ^-1 ^2 ^2 air if block ^-1 ^2 ^3 air if block ^-1 ^2 ^-3 air if block ^-1 ^2 ^-1 air if block ^-1 ^2 ^-2 air if block ^-1 ^2 ^ air if block ^-2 ^2 ^1 air if block ^-2 ^2 ^2 air if block ^-2 ^2 ^-1 air if block ^-2 ^2 ^-2 air if block ^-2 ^2 ^-3 air if block ^-2 ^2 ^3 air if block ^-2 ^2 ^ air run tag @s add Up

# Tp if not notUp
execute as @e[tag=tank_center,type=armor_stand,tag=!notUp,tag=Up] at @s run tp @s ~ ~1 ~


######## Reset Player Riding
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.0 air
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.1 air
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.2 air
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.3 air
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.4 air
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.5 air
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.6 air
# 7 is Ammo Slot
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run replaceitem entity @s container.8 air

#### Give Back Items
execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] positioned ~ ~254 ~ as @e[tag=hotbar_item,distance=0..10] positioned ~ ~-256 ~ run tp @s @p[tag=ride_initialized]

execute as @a[tag=ride_initialized] at @s unless entity @s[nbt={RootVehicle:{Entity:{id:"minecraft:minecart",Tags:["tank_seat"]}}}] run tag @s remove ride_initialized


############################
######## SHOOT LOOP ########
############################

execute as @e[type=armor_stand,tag=tank_projectile] at @s run function tank_pack:tank_projectile



######################
######## MICS ########
######################

# Clear Controls from dupers
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankl:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankfl:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankf:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankfr:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankr:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankb:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankbarrelup:1b}
clear @a[tag=!ride_initialized] minecraft:carrot_on_a_stick{tankbarreldown:1b}