######## Summon Tank ########
# AT AS ENGINE
scoreboard objectives add tank_fuel dummy
scoreboard objectives add tank_hp dummy

summon minecraft:armor_stand ~ ~-1 ~ {DisabledSlots:256,Invisible:1,NoGravity:1b,Invulnerable:1b,Tags:["tank_center","tank_part"],ShowArms:1b,Pose:{RightArm:[0f,0f,0f]},HandItems:[{id:"minecraft:diamond_hoe",Count:1b,tag:{CustomModelData:98761}}]}
summon minecraft:armor_stand ~ ~-1 ~ {DisabledSlots:256,Invisible:1,NoGravity:1b,Invulnerable:1b,Tags:["tank_turret","tank_part"],ShowArms:1b,Pose:{RightArm:[0f,0f,0f]},HandItems:[{id:"minecraft:diamond_hoe",Count:1b,tag:{CustomModelData:98762}}]}
summon minecraft:armor_stand ^ ^-0.5 ^-1 {DisabledSlots:16,Invisible:1,NoGravity:1b,Invulnerable:1b,Tags:["tank_barrel","tank_part"],Pose:{Head:[0f,0f,0f]},ArmorItems:[{},{},{},{id:"minecraft:diamond_hoe",Count:1b,tag:{CustomModelData:98763}}]}

#### Hitbox
summon minecraft:armor_stand ^2 ^-1 ^-4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_fr","tank_part"]}
summon minecraft:armor_stand ^1 ^-1 ^-4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_fr1","tank_part"]}
summon minecraft:armor_stand ^-1 ^-1 ^-4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_fl1","tank_part"]}
summon minecraft:armor_stand ^-2 ^-1 ^-4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_fl","tank_part"]}
summon minecraft:armor_stand ^ ^-1 ^-4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_f","tank_part"]}

summon minecraft:armor_stand ^-2 ^-1 ^4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_bl","tank_part"]}
summon minecraft:armor_stand ^2 ^-1 ^4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_br","tank_part"]}
summon minecraft:armor_stand ^-1 ^-1 ^4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_bl1","tank_part"]}
summon minecraft:armor_stand ^1 ^-1 ^4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_br1","tank_part"]}
summon minecraft:armor_stand ^ ^-1 ^4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_b","tank_part"]}


summon minecraft:armor_stand ^ ^0.75 ^-4 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_barrel","tank_part"]}
summon minecraft:armor_stand ^ ^0.75 ^-3 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_barrel2","tank_part"]}
summon minecraft:armor_stand ^ ^0.75 ^-2 {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_barrel3","tank_part"]}

summon minecraft:armor_stand ^-2 ^-1 ^ {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_l","tank_part"]}
summon minecraft:armor_stand ^2 ^-1 ^ {Invisible:1b,DisabledSlots:4144959,NoGravity:1b,Invulnerable:1b,Tags:["hitbox_r","tank_part"]}




#### Slime
#Invis ,ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1000000,ShowParticles:0b}]
summon minecraft:slime ^ ^0.5 ^-1 {Tags:["tank_rc_slime","tank_part"],NoGravity:1b,Silent:1b,Invulnerable:1b,PersistenceRequired:1b,NoAI:1b,Size:1,ActiveEffects:[{Id:14b,Amplifier:1b,Duration:1000000,ShowParticles:0b}]}

#Invis: 

summon minecraft:minecart ~ ~ ~ {NoGravity:1b,Invulnerable:1b,Tags:["tank_seat","tank_part"]}
summon minecraft:chest_minecart ^ ^-0.1 ^2.8 {CustomName:"{\"text\":\"Fuel & Storage\"}",NoGravity:1b,Invulnerable:1b,Tags:["tank_storage","tank_part"]}

######## Set Air

fill ^-1 ^ ^3 ^1 ^ ^3 air
fill ^-2 ^-1 ^-2 ^2 ^1 ^2 air
fill ^ ^1 ^ ^ ^1 ^-4 air

######## Set Rotation
execute as @s at @s if entity @s[y_rotation=90] run execute as @e[type=armor_stand,distance=0..5,name=!tank_engine] at @s run tp @s ~ ~ ~ -90 0
execute as @s at @s if entity @s[y_rotation=90] run execute as @e[type=minecart,distance=0..5] at @s run tp @s ~ ~ ~ -90 0

execute as @s at @s if entity @s[y_rotation=-90] run execute as @e[type=armor_stand,distance=0..5,name=!tank_engine] at @s run tp @s ~ ~ ~ 90 0
execute as @s at @s if entity @s[y_rotation=-90] run execute as @e[type=minecart,distance=0..5] at @s run tp @s ~ ~ ~ 90 0

execute as @s at @s if entity @s[y_rotation=0] run execute as @e[type=minecart,distance=0..5] at @s run tp @s ~ ~ ~ 180 0
execute as @s at @s if entity @s[y_rotation=0] run execute as @e[type=armor_stand,distance=0..5] at @s run tp @s ~ ~ ~ ~180 ~

execute as @e[type=armor_stand,distance=0..5] at @s run tp @s ~ ~1 ~ ~ ~
summon minecraft:armor_stand ~ ~ ~ {NoGravity:1b,Invulnerable:1b,Tags:["bug_fix_pls"]}
schedule function tank_pack:fix_graphic_bug 10t

######## Scoreboard Setup
scoreboard objectives add barrel_degree dummy 
execute as @e[tag=tank_barrel] run scoreboard players add @s barrel_degree 0
scoreboard objectives add barrel_cooldown dummy
execute as @e[tag=tank_barrel] run scoreboard players add @s barrel_cooldown 0
execute as @e[tag=tank_center,distance=0..2] run scoreboard players set @s tank_hp 100

#### Kill Engine
kill @s